//+------------------------------------------------------------------+
//|                                     TrendEnvelopeExpert_v2.2.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <stdlib.mqh>

//---- input parameters
extern string     Expert_Name    = "TrendEnvelopeExpert_v2.2";

extern int        Magic          = 22222;
extern int        Slippage       =     3;

extern string     Main_data      = " Trade Volume & Trade Method";
extern double     Lots           =   0.1;    // Trade Volume 
extern double     TakeProfit     =     0;    // Take Profit Value in pips 
extern double     StopLoss       =     0;    // Initial Stop Value in pips
extern int        TrailingMode   =     0;    // 0-off,1-standard,2-System by TE  
extern double     TrailingStop   =     0;    // Trailing Stop Value in pips
extern double     StopDeviation  =     0;    // Deviation of TrendEnvelopes line
extern double     BreakEven      =     0;    // Break-Even Value in pips
extern double     ProfitLock     =     0;    // Profit Lock in pips
extern int        ExitMode       =     0;    // System Exit Switch:0-off,1-TS,2-TE,3-AddSignal,4-any first,5-signal
extern bool       SignalMail     = False;    // E-mail Alert Switch

extern string     Time_Inputs    = " Timing parameters ";
extern int        StartHour      =     0;    // Start Hour of Trade Session 
extern int        StartMinute    =     0;    // Start Minute of Trade Session 
extern int        EndHour        =    23;    // End Hour of Trade Session
extern int        EndMinute      =     0;    // End Hour of Trade Session
extern int        CloseTimeMode  =     0;    // CloseTime mode: 0-off,1-on
extern int        CloseHour      =    24;    // Trade Close Hour   
extern int        CloseMinute    =     0;    // Trade Close Minute   
extern int        ProcessTime    =     5;    // Processing Time in min

extern string     TE_Inputs      = " TrendEnvelope parameters";
extern int        TE_TimeFrame   =     0;    // Time Frame in min
extern int        TE_MAPeriod    =    10;    // Period of Moving Average
extern int        TE_MAMode      =     0;    // Method of MA Calculation
extern int        TE_CurBar      =     1;    // Shift relative to the current bar
extern int        TE_Mode        =     2;    // TE Mode: 0-off,1-trend(confirmation),2-signal

extern string     TS_Inputs      = " TrendStrength parameters";
extern int        TS_TimeFrame   =     0;    // Time Frame in min
extern int        TS_Length      =    14;    // Period of evaluation
extern int        TS_Smooth      =     5;    // Period of smoothing
extern double     TS_K           = 4.236;    // Sensitivity Factor
extern int        TS_CurBar      =     1;    // Shift relative to the current bar
extern int        TS_Mode        =     1;    // TS Mode: 0-off,1-trend(confirmation),2-signal

extern string     Add_Inputs     = " Additional parameters";
extern int        Add_TimeFrame  =     0;    // Time Frame in min
extern int        haMA1_Period   =     5;    // Period of fast MAofHA
extern int        haMA1_Mode     =     3;    // Method of fast MAofHA
extern int        haMA2_Period   =    10;    // Period of slow MAofHA
extern int        haMA2_Mode     =     2;    // Method of slow MAofHA
extern int        MACD_Fast      =     8;    //    
extern int        MACD_Slow      =    21;    //
extern int        MACD_Signal    =     5;    // 
extern int        MACD_MAMode    =     1;    // Mode of MACD
extern int        RSI_Period     =     4;    // Period of RSI
extern int        Add_CurBar     =     1;    // Shift relative to the current bar
extern int        Add_Mode       =     1;    // Add Mode: 0-off,1-trend(confirmation),2-signal

extern string     MM_inputs      = " MoneyManagement by L.Williams ";
extern bool       MM             = false;    //  Switch
extern double     MaxRisk        =  0.05;    // Risk Factor
extern double     MaxLoss        =  1000;    // Maximum Loss by 1 Lot

int      OrderBar=0;
double   Lotsi;
int      BEvent=0, TriesNum=5;
datetime CurrBar,PrevBar;
double   UpLine, DnLine;
double   TStrend, pTStrend, TEtrend, pTEtrend, Addtrend, pAddtrend;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//---- 
   CurrBar = iTime(Symbol(),0,0);
   PrevBar = iTime(Symbol(),0,1);
//----
   return(0);
}

// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}  

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;      
   else
   if (StartHour > EndHour)
   result = (TimeCurrent() > SessionStart && TimeHour(TimeCurrent()) < 24)
          ||(TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   
   return(result);
}   
   
int TS_Trend(int mode)
{   
   int result = 0; 
   
   TStrend  = iCustom(Symbol(),TS_TimeFrame,"TrendStrength_v2",TS_Length,TS_Smooth,TS_K,7,TS_CurBar);
   pTStrend = iCustom(Symbol(),TS_TimeFrame,"TrendStrength_v2",TS_Length,TS_Smooth,TS_K,7,TS_CurBar+1);
          
   if (mode == 1)
   {
   if (TStrend > 0) result =  mode;
   if (TStrend < 0) result = -mode; 
   }
   else
   if (mode == 2)
   {
   if (TStrend > 0 && pTStrend < 0) result =  mode;  
   if (TStrend < 0 && pTStrend > 0) result = -mode;
   }
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

int TE_Trend(int mode)
{   
   int result = 0; 
   
   TEtrend  = iCustom(Symbol(),TE_TimeFrame,"TrendEnvelopes_v2",TE_MAPeriod,TE_MAMode,1,0,6,TE_CurBar);
   pTEtrend = iCustom(Symbol(),TE_TimeFrame,"TrendEnvelopes_v2",TE_MAPeriod,TE_MAMode,1,0,6,TE_CurBar+1);
   //Print("TEtrend=",TEtrend);       
   if (mode == 1)
   {
   if (TEtrend > 0) result =  mode;
   if (TEtrend < 0) result = -mode; 
   }
   else
   if (mode == 2)
   {
   if (TEtrend > 0 && pTEtrend < 0) result =  mode;  
   if (TEtrend < 0 && pTEtrend > 0) result = -mode;
   }
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

int Add_Trend(int mode)
{   
   int result = 0; 
   
   Addtrend  = iCustom(Symbol(),Add_TimeFrame,"AddSignal_v1",haMA1_Period,haMA1_Mode,
   haMA2_Period,haMA2_Mode,MACD_Fast,MACD_Slow,MACD_Signal,MACD_MAMode,RSI_Period,2,Add_CurBar);
   
   pAddtrend  = iCustom(Symbol(),Add_TimeFrame,"AddSignal_v1",haMA1_Period,haMA1_Mode,
   haMA2_Period,haMA2_Mode,MACD_Fast,MACD_Slow,MACD_Signal,MACD_MAMode,RSI_Period,2,Add_CurBar+1);
      
   if (mode == 1)
   {
   if (Addtrend > 0) result =  mode;
   if (Addtrend < 0) result = -mode; 
   }
   else
   if (mode == 2)
   {
   if (Addtrend > 0 && pAddtrend < 0) result =  mode;
   if (Addtrend < 0 && pAddtrend > 0) result = -mode; 
   }
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

int TradeSignal()
{   
   int Signal =0;
   
   if (TE_Mode>0) int TE  = TE_Trend(TE_Mode); else TE=0; 
   if (TS_Mode>0) int TS =  TS_Trend(TS_Mode); else TS=0;
   if (Add_Mode>0) int AD =  Add_Trend(Add_Mode); else AD=0; 
   
   //Print("TE=",TE," TS=",TS," AD=",AD);  
   
   if (TimeCondition())
   {
   if ( TE == TE_Mode && TS == TS_Mode && AD == Add_Mode) Signal = 1;
   if ( TE ==-TE_Mode && TS ==-TS_Mode && AD ==-Add_Mode) Signal =-1;
   }  
 
   return(Signal);
}

double MoneyManagement()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract=MarketInfo(Symbol(),MODE_LOTSIZE);
   double vol;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
   if ( MM )
   vol=NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2);
   else
   vol=Lots;
//--- check min, max and step
   vol=NormalizeDouble(vol/lot_step,0)*lot_step;
   if(vol<lot_min) vol=lot_min;
   if(vol>lot_max) vol=lot_max;
//---
   return(vol);
}   


void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY) 
         {
			   if ( BreakEven > 0 && BEvent==0 )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/Point;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice()+ProfitLock*Point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+ProfitLock*Point,Digits);
			      BEvent=1;
			      }
			   }
			   else 			   
			   if( TrailingMode==1 && TrailingStop > 0 ) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*Point,Digits);
			   else
			   if( TrailingMode==2 && UpLine>0) BuyStop = NormalizeDouble((1.0-0.01*StopDeviation)*UpLine,Digits);
			   
			   if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop) 
            {   
			      if ( BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if ( BreakEven > 0 && BEvent==0)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/Point;
			   
			      if( Gain >= BreakEven && (OrderStopLoss()>=OrderOpenPrice()-ProfitLock*Point || OrderStopLoss()== 0)) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-ProfitLock*Point,Digits);
			      BEvent=-1;
			      }
			   }
			   else 
			   if (TrailingStop > 0 && TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*Point,Digits);   
            else
            if( TrailingMode==2 && DnLine>0) SellStop = NormalizeDouble((1.0+0.01*StopDeviation)*DnLine,Digits);
                        
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop>0) 
            {
               if( SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   			}	    
         }
      }
   }     
}


// ---- Open Sell Orders
void SellOrdOpen()
{		     
   double SellPrice = Bid;
   double StopPrice = Bid;
   int    Mode = OP_SELL;
        	  
   if (StopLoss > 0) double SellStop  = StopPrice + StopLoss*Point; 
	else 
	if( TrailingMode==2 && DnLine>0) SellStop = NormalizeDouble((1.0+0.01*StopDeviation)*DnLine,Digits); 
	else SellStop = 0;
   
   if (TakeProfit  > 0) double SellProfit = SellPrice - TakeProfit*Point; else SellProfit=0;
   
	int ticket = OrderSend( Symbol(),Mode,MoneyManagement(),
	                        NormalizeDouble(SellPrice , Digits),
	                        Slippage,
	                        NormalizeDouble(SellStop  , Digits),
	                        NormalizeDouble(SellProfit, Digits),
	                        Expert_Name+" SELL",Magic,0,Red);
   
   if(ticket > 0) 
   {
      if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		//OrderBar =iBars(OrderSymbol(),BT_TimeFrame);
		Print("SELL order opened : ", OrderOpenPrice());
      BEvent=0;
      if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
		}
   }
	else 	
   if(GetLastError()>0)
   Print("SELL: OrderSend failed with error #",GetLastError());
   
   return(0);
}
// ---- Open Buy Orders
void BuyOrdOpen()
{		     
   double BuyPrice  = Ask;
   double StopPrice = Ask;
   int    Mode      = OP_BUY;
      
   if (StopLoss > 0) double BuyStop  = StopPrice - StopLoss*Point; 
	else 
	if ( TrailingMode==2 && UpLine > 0) BuyStop = NormalizeDouble((1.0-0.01*StopDeviation)*UpLine,Digits); 
	else BuyStop = 0;
   
   if (TakeProfit  > 0) double BuyProfit= BuyPrice + TakeProfit*Point; else BuyProfit=0;  
		 
	int ticket = OrderSend(Symbol(),Mode, MoneyManagement(),
	                   NormalizeDouble(BuyPrice , Digits),
	                   Slippage,
	                   NormalizeDouble(BuyStop  , Digits), 
	                   NormalizeDouble(BuyProfit, Digits),
	                   Expert_Name+" BUY",Magic,0,Blue);
      
   if(ticket > 0) 
   {
      if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		//OrderBar =iBars(OrderSymbol(),BT_TimeFrame); 
		Print("BUY order opened : ", OrderOpenPrice());
      BEvent=0;
      if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
		}
   }
	else 	
   if(GetLastError()>0)      
   Print("BUY : OrderSend failed with error #",GetLastError());

   return(0);
} 

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=0; i<=OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua);
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) result=CloseAtMarket(OrderTicket(),OrderLots(),Pink);
      }
   }
}


bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      //ntr=0; 
      //while (ntr<5 && !IsTradeAllowed()) { ntr++; Sleep(5000); }
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if (TS_TimeFrame==0) TS_TimeFrame = Period();
   if (TE_TimeFrame==0) TE_TimeFrame = Period();
   if (Add_TimeFrame==0) Add_TimeFrame = Period();  
    
   if(iBars(Symbol(),TE_TimeFrame) < 100 || IsTradeAllowed()==false) return(0); 
      
   if(AccountFreeMargin()< 1000*MoneyManagement ())
   {
   Print("We have no money. Free Margin = ", AccountFreeMargin());
   return(0);  
   }
   CurrBar = iTime(Symbol(),0,0);
   
   datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
   
   
   
   if (CurrBar != PrevBar)
   {
      if(TrailingMode==2)
      {
      UpLine  = iCustom(Symbol(),TE_TimeFrame,"TrendEnvelopes_v2",TE_MAPeriod,TE_MAMode,0,0,0,TE_CurBar);
      DnLine  = iCustom(Symbol(),TE_TimeFrame,"TrendEnvelopes_v2",TE_MAPeriod,TE_MAMode,0,0,1,TE_CurBar);
      }
            
      int Signal = TradeSignal();
      //Print(" Sig=",Signal);      
      if(ScanTrades()>0)
      {
         if(ExitMode == 1)
         {
         int TSdir  = iCustom(Symbol(),TS_TimeFrame,"TrendStrength_v2",TS_Length,TS_Smooth,TS_K,7,TS_CurBar);
         if (TSdir > 0) CloseOrder(2);
         if (TSdir < 0) CloseOrder(1);
         }
         else
         if(ExitMode == 2)
         {
         int TEdir  = iCustom(Symbol(),TE_TimeFrame,"TrendEnvelopes_v2",TE_MAPeriod,TE_MAMode,1,0,6,TE_CurBar);
         if (TEdir > 0) CloseOrder(2);
         if (TEdir < 0) CloseOrder(1);
         }
         else
         if(ExitMode == 3)
         {
         int Addir  = iCustom(Symbol(),Add_TimeFrame,"AddSignal_v1",haMA1_Period,haMA1_Mode,
         haMA2_Period,haMA2_Mode,MACD_Fast,MACD_Slow,MACD_Signal,MACD_MAMode,RSI_Period,2,Add_CurBar);
         if (Addir >0 ) CloseOrder(2);
         if (Addir <0 ) CloseOrder(1);
         }
         else
         if(ExitMode == 4)
         {
         //Print("TS_main=",TS_main," TS_sig=",TS_sig," trend=",trend);
         if (TStrend > 0 || TStrend > 0 || Addtrend >0 ) CloseOrder(2);
         if (TStrend < 0 || TStrend < 0 || Addtrend <0 ) CloseOrder(1);
         }
         else
         if(ExitMode == 5)
         {
         if (Signal > 0) CloseOrder(2);
         if (Signal < 0) CloseOrder(1);
         }
      
      if (CloseTimeMode > 0 && TimeCurrent() >= TimeClose) CloseOrder(0); 
      }
      
      if(ScanTrades()==0)
      {
      if (Signal > 0) BuyOrdOpen() ;
      if (Signal < 0) SellOrdOpen();
      }
   }
   else
   if(ScanTrades()>0)
   {
   if(BreakEven > 0 || TrailingMode>0) TrailStop();
   }
   PrevBar = CurrBar;
   
//----
   return(0);
} //start()
//+------------------------------------------------------------------+